package betterwithmods.common.blocks.mechanical;

import betterwithmods.BWMod;
import betterwithmods.api.block.IMechanicalBlock;
import betterwithmods.api.block.IMultiVariants;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BWMBlock;
import betterwithmods.common.blocks.tile.TileEntityFilteredHopper;
import betterwithmods.common.blocks.tile.TileEntityMill;
import betterwithmods.common.blocks.tile.TileEntityPulley;
import betterwithmods.common.blocks.tile.TileEntityTurntable;
import betterwithmods.module.gameplay.MechanicalBreakage;
import betterwithmods.util.InvUtils;
import betterwithmods.util.MechanicalUtil;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.*;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.items.CapabilityItemHandler;

import javax.annotation.Nullable;
import java.util.Random;

public class BlockMechMachines extends BWMBlock implements IMechanicalBlock, IMultiVariants {

    public static final PropertyBool ACTIVE = PropertyBool.func_177716_a("ison");
    public static final PropertyEnum<BlockMechMachines.EnumType> TYPE = PropertyEnum.func_177709_a("machinetype", BlockMechMachines.EnumType.class);
    public BlockMechMachines() {
        super(Material.field_151576_e);
        this.func_149675_a(true);
        this.func_149711_c(3.5F);
        this.func_180632_j(this.field_176227_L.func_177621_b()
                .func_177226_a(TYPE, BlockMechMachines.EnumType.MILL)
                .func_177226_a(ACTIVE, false)
        );
        this.field_149783_u = true;
    }

    public static ItemStack getStack(EnumType type) {
        return new ItemStack(BWMBlocks.SINGLE_MACHINES, 1, type.getMeta());
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        switch (state.func_177229_b(TYPE)) {
            case HOPPER:
                return new AxisAlignedBB(0,4/16d,0,1,1,1);
            default:
                return super.func_185496_a(state, source, pos);
        }
    }

    @Override
    public String[] getVariants() {
        return new String[]{
                "ison=false,machinetype=mill",
                "ison=false,machinetype=pulley",
                "ison=false,machinetype=hopper",
                "ison=false,machinetype=turntable",
                "ison=true,machinetype=mill",
                "ison=true,machinetype=pulley",
                "ison=true,machinetype=hopper",
                "ison=true,machinetype=turntable",
        };
    }

    @SuppressWarnings("deprecation")
    @Override
    public Material func_149688_o(IBlockState state) {
        switch (state.func_177229_b(TYPE)) {
            case HOPPER:
            case PULLEY:
                setHarvestLevel("axe", 0, state);
                return Material.field_151575_d;
            default:
                setHarvestLevel("pickaxe", 0, state);
                return super.func_149688_o(state);
        }
    }

    @Override
    public SoundType getSoundType(IBlockState state, World world, BlockPos pos, @Nullable Entity entity) {
        switch (state.func_177229_b(TYPE)) {
            case HOPPER:
            case PULLEY:
                return SoundType.field_185848_a;
            default:
                return super.getSoundType(state, world, pos, entity);
        }
    }

    @Override
    public boolean isSideSolid(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing side) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        return type == EnumType.MILL || type == EnumType.PULLEY || type == EnumType.TURNTABLE;
    }

    public int tickRateForMeta(EnumType type) {
        if (type == EnumType.MILL)
            return 1;
        return 10;
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        super.func_176213_c(world, pos, state);
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        world.func_180497_b(pos, this, tickRateForMeta(type), 5);
    }

    @Override
    public EnumBlockRenderType func_149645_b(IBlockState state) {
        return EnumBlockRenderType.MODEL;
    }

    @Override
    public int func_180651_a(IBlockState state) {
        BlockMechMachines.EnumType type = state.func_177229_b(TYPE);
        return type.getMeta();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }

    @Override
    public boolean func_149662_c(IBlockState state) {

        return state.func_177229_b(TYPE).getSolidity();
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return state.func_177229_b(TYPE).getSolidity();
    }

    @Override
    public boolean func_149730_j(IBlockState state) {
        return state.func_177229_b(TYPE).getSolidity();
    }


    @Override
    public boolean func_176214_u(IBlockState state) {
        return state.func_177229_b(TYPE).getSolidity();
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (world.field_72995_K) {
            return true;
        } else {
            if (world.func_175625_s(pos) != null && world.func_175625_s(pos).hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null)) {
                player.openGui(BWMod.instance, 0, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            } else {
                if (world.func_175625_s(pos) != null && world.func_175625_s(pos) instanceof TileEntityTurntable && hand == EnumHand.MAIN_HAND) {
                    return ((TileEntityTurntable) world.func_175625_s(pos)).processRightClick(player);
                }
            }
            return true;
        }
    }

    public boolean func_149740_M(IBlockState state) {
        return true;
    }

    public int func_180641_l(IBlockState blockState, World worldIn, BlockPos pos) {
        TileEntity tile = worldIn.func_175625_s(pos);
        if (tile != null && tile.hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null)) {
            if (tile.hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null)) {
                return InvUtils.calculateComparatorLevel(tile.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null));
            }
        }
        return 0;
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        boolean gettingPower = this.isInputtingMechPower(world, pos);
        boolean isOn = isMechanicalOn(world, pos);

        if (world.func_175625_s(pos) instanceof TileEntityTurntable) {
            if (!world.func_82736_K().func_82766_b("doDaylightCycle"))
                ((TileEntityTurntable) world.func_175625_s(pos)).toggleAsynchronous(null);
        }

        if (isOn != gettingPower)
            setMechanicalOn(world, pos, gettingPower);
    }

    @Override
    public void func_189540_a(IBlockState state, World world, BlockPos pos, Block block, BlockPos other) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        if (!isCurrentStateValid(world, pos)) {
            world.func_180497_b(pos, this, tickRateForMeta(type), 5);
        }
    }

    public boolean isCurrentStateValid(World world, BlockPos pos) {
        boolean gettingPower = isInputtingMechPower(world, pos);
        boolean isOn = isMechanicalOn(world, pos);
        return isOn == gettingPower;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Override
    public TileEntity createTileEntity(World world, IBlockState state) {
        switch (state.func_177229_b(TYPE)) {
            case MILL:
                return new TileEntityMill();
            case PULLEY:
                return new TileEntityPulley();
            case HOPPER:
                return new TileEntityFilteredHopper();
            case TURNTABLE:
                return new TileEntityTurntable();
        }
        return null;
    }

    @Override
    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        for (EnumType type : EnumType.META_LOOKUP)
            items.add(getStack(type));
    }

    @Override
    public boolean canOutputMechanicalPower() {
        return false;
    }

    @Override
    public boolean canInputMechanicalPower() {
        return true;
    }

    @Override
    public boolean isInputtingMechPower(World world, BlockPos pos) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        if (type != EnumType.TURNTABLE)
            return MechanicalUtil.isBlockPoweredByAxle(world, pos, this) || MechanicalUtil.isPoweredByCrank(world, pos);
        else
            return MechanicalUtil.isBlockPoweredByAxle(world, pos, this);
    }

    @Override
    public boolean isOutputtingMechPower(World world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canInputPowerToSide(IBlockAccess world, BlockPos pos,
                                       EnumFacing dir) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        switch (type) {
            case MILL:
                return dir == EnumFacing.UP || dir == EnumFacing.DOWN;
            case PULLEY:
                return dir != EnumFacing.DOWN && dir != EnumFacing.UP;
            case HOPPER:
                return dir != EnumFacing.UP && dir != EnumFacing.DOWN;
            case TURNTABLE:
                return dir == EnumFacing.DOWN;
        }
        return false;
    }

    @Override
    public void overpower(World world, BlockPos pos) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        if (!world.field_72995_K) {
            switch (type) {
                case MILL:
                    breakMill(world, pos);
                    break;
                case PULLEY:
                    breakPulley(world, pos);
                    break;
                case HOPPER:
                    breakHopper(world, pos);
                    break;
                case TURNTABLE:
                    breakTurntable(world, pos);
                    break;
                default:
                    break;
            }
        }
    }

    private void breakMill(World world, BlockPos pos) {
        if (MechanicalBreakage.millstone)
            InvUtils.ejectBrokenItems(world, pos, new ResourceLocation(BWMod.MODID, "block/mill"));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F, world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    private void breakPulley(World world, BlockPos pos) {
        if (MechanicalBreakage.pulley)
            InvUtils.ejectBrokenItems(world, pos, new ResourceLocation(BWMod.MODID, "block/pulley"));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F, world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    public void breakHopper(World world, BlockPos pos) {
        if (MechanicalBreakage.hopper)
            InvUtils.ejectBrokenItems(world, pos, new ResourceLocation(BWMod.MODID, "block/hopper"));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F, world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    private void breakTurntable(World world, BlockPos pos) {
        if (MechanicalBreakage.turntable)
            InvUtils.ejectBrokenItems(world, pos, new ResourceLocation(BWMod.MODID, "block/turntable"));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F, world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_180655_c(IBlockState state, World world, BlockPos pos, Random rand) {
        BlockMechMachines.EnumType type = world.func_180495_p(pos).func_177229_b(TYPE);
        boolean isOn = world.func_180495_p(pos).func_177229_b(ACTIVE);
        if (type == BlockMechMachines.EnumType.MILL && isOn)
            updateMill(world, pos, rand);
    }

    public void updateMill(World world, BlockPos pos, Random rand) {
        if (isMechanicalOn(world, pos)) {
            emitSmoke(world, pos, rand, 5);
        }
    }

    private void emitSmoke(World world, BlockPos pos, Random rand, int heat) {
        for (int i = 0; i < heat; i++) {
            int x = pos.func_177958_n();
            int y = pos.func_177956_o();
            int z = pos.func_177952_p();
            float fX = x + rand.nextFloat();
            float fY = y + rand.nextFloat() * 0.5F + 1.0F;
            float fZ = z + rand.nextFloat();
            world.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, fX, fY, fZ, 0.0D, 0.0D, 0.0D);
        }
    }

    @Override
    public EnumFacing getFacingFromBlockState(IBlockState state) {
        return null;
    }

    @Override
    public IBlockState setFacingInBlock(IBlockState state, EnumFacing facing) {
        return state;
    }

    @Override
    public boolean canRotateOnTurntable(IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canRotateHorizontally(IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canRotateVertically(IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean isMechanicalOn(IBlockAccess world, BlockPos pos) {
        return isMechanicalOnFromState(world.func_180495_p(pos));
    }

    @Override
    public void setMechanicalOn(World world, BlockPos pos, boolean isOn) {
        if (isOn != world.func_180495_p(pos).func_177229_b(ACTIVE)) {
            world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(ACTIVE, isOn));
        }
    }

    @Override
    public boolean isMechanicalOnFromState(IBlockState state) {
        return state.func_177229_b(ACTIVE);
    }

    public boolean isRedstonePowered(World world, BlockPos pos) {
        return world.func_175687_A(pos) > 0;
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, ACTIVE, TYPE);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(TYPE, EnumType.byMeta(meta)).func_177226_a(ACTIVE, meta > 3);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(TYPE).getMeta() + (state.func_177229_b(ACTIVE) ? 4 : 0);
    }



    public enum EnumType implements IStringSerializable {
        MILL(0, "mill", true),
        PULLEY(1, "pulley", true),
        HOPPER(2, "hopper"),
        TURNTABLE(3, "turntable", true);

        private static final BlockMechMachines.EnumType[] META_LOOKUP = values();

        private int meta;
        private String name;
        private boolean solidity;

        EnumType(int meta, String name) {
            this(meta, name, false);
        }

        EnumType(int meta, String name, boolean solid) {
            this.meta = meta;
            this.name = name;
            this.solidity = solid;
        }

        public static BlockMechMachines.EnumType byMeta(int meta) {
            return META_LOOKUP[meta % META_LOOKUP.length];
        }

        @Override
        public String func_176610_l() {
            return name;
        }

        public int getMeta() {
            return meta;
        }

        public boolean getSolidity() {
            return solidity;
        }
    }
}
